
#import "AppController.h"
#import "PreferenceController.h"

@implementation AppController

- (void) awakeFromNib
{
    timer = [[NSTimer scheduledTimerWithTimeInterval: 30
                    target: self
                  selector: @selector(checkTime:)
                  userInfo: nil
                   repeats: YES] retain];
    preferenceController = [[PreferenceController alloc] init];

} // awakeFromNib


- (void) checkTime: (NSTimer *)timer
{
    char ook[1024];
    struct tm *tm;
    time_t clock;
    int minutes;
    NSNumber *number;
    NSSet *alertTimes = [preferenceController alertTimes];
    NSString *messageText = [preferenceController alertMessage];

    clock = time(NULL);
    tm = localtime(&clock);
    strftime (ook, 1024, "%M", tm); // get the minutes of the hour
    minutes = atoi (ook);
    
    number = [NSNumber numberWithInt: minutes];

    if ([alertTimes containsObject: number]) {
        
        if ([preferenceController shouldAlert]) {
            [NSApp activateIgnoringOtherApps: YES];
            [message setStringValue: messageText];
            [window center];
            [window makeKeyAndOrderFront: nil];
        }
        if ([preferenceController shouldBounce]) {
            [NSApp requestUserAttention: NSCriticalRequest];
        }
    }
} // checkTime


- (IBAction) showPreferencePanel: (id) sender
{
    NSLog (@"Show Preference Panel!");

    [preferenceController showWindow: self];
    
} // showPreferencePanel



@end // AppController
